Index: xend_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xend_internal.c,v
retrieving revision 1.151
diff -u -p -r1.151 xend_internal.c
--- xend_internal.c	22 Oct 2007 20:28:55 -0000	1.151
+++ xend_internal.c	23 Oct 2007 05:01:42 -0000
@@ -1438,8 +1438,15 @@ xend_parse_sexp_desc(virConnectPtr conn,
     if ((cur_mem >= MIN_XEN_GUEST_SIZE) && (cur_mem != max_mem))
 	virBufferVSprintf(&buf, "  <currentMemory>%d</currentMemory>\n",
 	                  cur_mem);
-    virBufferVSprintf(&buf, "  <vcpu>%d</vcpu>\n",
+
+    virBufferVSprintf(&buf, "  <vcpu");
+    tmp = sexpr_node(root, "domain/cpus");
+    if (tmp != NULL) {
+        virBufferVSprintf(&buf, " cpuset='%s'", tmp );
+    }
+    virBufferVSprintf(&buf, ">%d</vcpu>\n",
                       sexpr_int(root, "domain/vcpus"));
+
     tmp = sexpr_node(root, "domain/on_poweroff");
     if (tmp != NULL)
         virBufferVSprintf(&buf, "  <on_poweroff>%s</on_poweroff>\n", tmp);
Index: xm_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xm_internal.c,v
retrieving revision 1.41
diff -u -p -r1.41 xm_internal.c
--- xm_internal.c	10 Oct 2007 17:55:38 -0000	1.41
+++ xm_internal.c	23 Oct 2007 05:01:42 -0000
@@ -660,11 +660,12 @@ char *xenXMDomainFormatXML(virConnectPtr
             val = MIN_XEN_GUEST_SIZE * 2;
     virBufferVSprintf(buf, "  <memory>%ld</memory>\n", val * 1024);
 
-
+    virBufferVSprintf(buf, "  <vcpu");
+    if (xenXMConfigGetString(conf, "cpus", &str) == 0)
+        virBufferVSprintf(buf, " cpuset='%s'", str);
     if (xenXMConfigGetInt(conf, "vcpus", &val) < 0)
         val = 1;
-    virBufferVSprintf(buf, "  <vcpu>%ld</vcpu>\n", val);
-
+    virBufferVSprintf(buf, ">%ld</vcpu>\n", val);
 
     if (xenXMConfigGetString(conf, "on_poweroff", &str) < 0)
         str = "destroy";
@@ -1821,6 +1822,11 @@ virConfPtr xenXMParseXMLToConfig(virConn
                                    "cannot set vcpus config parameter") < 0)
         goto error;
 
+    if (xenXMConfigSetStringFromXPath(conn, conf, ctxt, "cpus",
+                                      "string(/domain/vcpu/@cpuset)", 1,
+                                      "cannot set the cpuset parameter") < 0)
+            goto error;
+
     obj = xmlXPathEval(BAD_CAST "string(/domain/os/type)", ctxt);
     if ((obj != NULL) && (obj->type == XPATH_STRING) &&
         (obj->stringval != NULL) && !strcmp((char*)obj->stringval, "hvm"))
